//BeamRifle.cs

//audio
datablock AudioProfile(BeamRifleShotSound)
{
   filename    = "./LaserRifleShot.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(BeamRifleChargeSound)
{
   filename    = "./LaserCharge.wav";
   description = AudioClosest3d;
   preload = true;
};

//trail
datablock ParticleData(BeamRifleTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 100;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "0.0 0.0 1 1";
	colors[1]	= "0.2 0.2 1 0.4";
	sizes[0]	= 0.2;
	sizes[1]	= 0.3;
	//times[0]	= 0.5;
	//times[1]	= 0.5;
};

datablock ParticleEmitterData(BeamRifleTrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = BeamRifleTrailParticle;

   useEmitterColors = true;
   uiName = "";
};

//muzzle flash effects
datablock ParticleData(BeamRifleFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.0 0.0 0.9 0.9";
	colors[1]     = "0.0 0.0 0.4 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(BeamRifleFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BeamRifleFlashParticle";

   uiName = "";
};

datablock ExplosionData(BeamRifleExplosion)
{
   //explosionShape = "";
	soundProfile = LaserHitSound;

   lifeTimeMS = 150;

   particleEmitter = LaserExplosionEmitter;
   particleDensity = 9;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 4;
   lightEndRadius = 3;
   lightStartColor = "0.2 0.2 0.9";
   lightEndColor = "0 0 0";
};


AddDamageType("BeamRifle",   '<bitmap:add-ons/Weapon_BeamRifle/CI_BeamRifle> %1',    '%2 <bitmap:add-ons/Weapon_BeamRifle/CI_BeamRifle> %1',0.2,1);
datablock ProjectileData(BeamRifleProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 40;
   directDamageType    = $DamageType::BeamRifle;
   radiusDamageType    = $DamageType::BeamRifle;

   brickExplosionRadius = 0.25;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 20;
   brickExplosionMaxVolume = 250;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 360;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 300;
   verticalImpulse	  = 200;
   explosion           = BeamRifleExplosion;
   particleEmitter     = BeamRifleTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = True;
   lightRadius = 4.0;
   lightColor  = ".2 0. 0.75";

   uiName = "Beam Rifle Laser";
};

//////////
// item //
//////////
datablock ItemData(BeamRifleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./BeamRifle.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Beam Rifle";
	iconName = "./icon_BeamRifle";
	doColorShift = false;
	colorShiftColor = "1 1 1 1.000";

	 // Dynamic properties defined by the scripts
	image = BeamRifleImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(BeamRifleImage)
{
   // Basic Item properties
   shapeFile = "./BeamRifle.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = BeamRifleProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = False;
   colorShiftColor = BeamRifleItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.8;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Charge";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]			= "Charge";
	statetransitionOnTimeOut[2]	= "ChargeFull";
	stateTransitiononTriggerup[2]   = "Fire";
	stateWaitForTimeout[2]		= false;
	stateAllowImageChange[1]        = true;
	stateSound[2]			= BeamRifleChargeSound;
	stateTimeoutValue[2]		= 0.9;
	

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Reload";
	stateTimeoutValue[3]            = 0.74;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateEmitter[3]					= BeamRifleFlashEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateSound[3]					= BeamRifleShotSound;

	stateName[4]			= "ChargeFull";
	stateAllowImageChange[4]         = true;
	stateTransitiononTriggerup[4]   = "ChargeFire";

	stateName[5]                    = "ChargeFire";
	stateTransitionOnTimeout[5]     = "Reload";
	stateTimeoutValue[5]            = 1;
	stateFire[5]                    = true;
	stateAllowImageChange[5]        = false;
	stateSequence[5]                = "Fire";
	stateScript[5]                  = "onChargeFire";
	stateWaitForTimeout[5]			= true;
	stateEmitter[5]					= BeamRifleFlashEmitter;
	stateEmitterTime[5]				= 0.05;
	stateEmitterNode[5]				= "muzzleNode";
	stateSound[5]					= BeamRifleShotSound;

	stateName[6]			= "Reload";
	stateSequence[6]                = "Reload";
	stateTimeoutValue[3]            = 1.1;
	stateTransitionOntimeout[6]   = "Ready";
	stateSequence[6]	        = "Ready";

};

function BeamRifleImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);
	Parent::onFire(%this,%obj,%slot);	
}

function BeamRifleImage::onChargeFire(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();
      
	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-3")));
	%obj.playThread(2, shiftAway);

	%projectile = %this.projectile;
	%spread = 0;
	%shellcount = 3;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}